package test.appProfConverter;
import org.w3c.dom.Element;

public class PhaseState {
	public PhaseState(Element e) throws Exception {
		LoadElement(e);
	}

	private void LoadElement(Element e) throws Exception {
		if (!e.getTagName().equals("PState")) {
			throw new Exception("Invalid element tag.");
		}

		State = Integer.parseInt(e.getElementsByTagName("State").item(0)
				.getChildNodes().item(0).getNodeValue().trim());
		Frequency = Double.parseDouble(e.getElementsByTagName("Frequency")
				.item(0).getChildNodes().item(0).getNodeValue().trim());
		Voltage = Double.parseDouble(e.getElementsByTagName("Voltage").item(0)
				.getChildNodes().item(0).getNodeValue().trim());
		PowerUsageMin = Double.parseDouble(e
				.getElementsByTagName("PowerUsageMin").item(0).getChildNodes()
				.item(0).getNodeValue().trim());
		PowerUsageMax = Double.parseDouble(e
				.getElementsByTagName("PowerUsageMax").item(0).getChildNodes()
				.item(0).getNodeValue().trim());
	}

	public Integer State;
	public Double Frequency;
	public Double Voltage;
	public Double PowerUsageMin;
	public Double PowerUsageMax;

	public String ToString() {
		String str = "";
		str += "  State Id:       " + this.State + "\n";
		str += "   Frequency:     " + Double.toString(this.Frequency) + " MHz\n";
		str += "   Voltage:       " + Double.toString(this.Voltage) + " V\n";
		str += "   PowerUsageMin: " + Double.toString(this.PowerUsageMin) + " W\n";
		str += "   PowerUsageMax: " + Double.toString(this.PowerUsageMax) + " W\n";
		return str;
	}

}
